/*!
 * @file functor_member.h
 * Definition of an Functor
 */

/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/


#ifndef __FUNCTOR_MEMBER_H_
#define __FUNCTOR_MEMBER_H_

#include "executor_member.h"
#include "substring.h"

#define FUNCTOR_CALL_TYPE const SubString

/// Define all Constructs, that define an Executor.

//! The Name to be attached to the functional (for normal, static, and const modes)
#define __EXECUTOR_FUNCTIONAL_NAME(ParamCount)   Executor##ParamCount##Params
//! if Functional is constant calling
#define __EXECUTOR_FUNCTIONAL_CONST
//! The Function-Pointer, and how to save it internally.
#define __EXECUTOR_FUNCTIONAL_FUNCTION_POINTER   T::*functionPointer
//! The Type of Function
#define __EXECUTOR_FUNCTIONAL_FUNCTIONTYPE       Executor<CallType, BaseClass>::FunctionMember


/// Now we include The generic Functor, that generate the functions.
#include "functor_generic.h"


#undef __EXECUTOR_FUNCTIONAL_NAME
#undef __EXECUTOR_FUNCTIONAL_CONST
#undef __EXECUTOR_FUNCTIONAL_FUNCTION_POINTER
#undef __EXECUTOR_FUNCTIONAL_FUNCTIONTYPE



#endif /* __FUNCTOR_MEMBER_H_ */
